//SilverChariot.cs
datablock TSShapeConstructor(SilverChariotDts)
{
	baseShape  = "./SilverChariot.dts";
	sequence0  = "./sc_root.dsq root";
	sequence1  = "./sc_slash.dsq slash";
};   

datablock AudioProfile(OREMOSTANDATOSound)
{
   filename    = "./oremostandato.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SilverChariotFireSound)
{
   filename    = "./slash.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

//projectile
AddDamageType("SilverChariot",   '<bitmap:add-ons/Weapon_SilverChariot/CI_SilverChariot> %1',    '%2 <bitmap:add-ons/Weapon_SilverChariot/CI_SilverChariot> %1',0.75,1);
datablock ProjectileData(SilverChariotProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 30;
   directDamageType  = $DamageType::SilverChariot;
   radiusDamageType  = $DamageType::SilverChariot;
   particleemitter	   = swordExplosionEmitter;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 150;
   lifetime            = 150;
   fadeDelay           = 150;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "SilverChariot Slice";
};


//////////
// item //
//////////
datablock ItemData(SilverChariotItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./SilverChariot.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Silver Chariot";
	iconName = "./icon_SilverChariot";

	 // Dynamic properties defined by the scripts
	image = PORUNAREFFImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SilverChariotImage)
{
   // Basic Item properties
   shapeFile = "./SilverChariot.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 7;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.9 0.0 -1.5";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SilverChariotItem;
   ammo = " ";
   projectile = SilverChariotProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateSequence[0]		 = "root";
};


datablock ShapeBaseImageData(SilverChariotSlashingImage : SilverChariotImage)
{
	stateName[0]                     = "Activate";
	stateSequence[0]		 = "slash";
};

datablock ShapeBaseImageData(PORUNAREFFImage)
{
	// Basic Item properties
	emap = true;
	shapeFile = "base/data/shapes/empty.dts";

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 -0.35 0.35";
	rotation = eulerToMatrix("0 0 180");

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = false;

	eyeOffset = "0 0 0";

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

	// Projectile && Ammo.
	item = SilverChariotItem;
	ammo = " ";
	projectile = SilverChariotProjectile;
	projectileType = Projectile;

	//melee particles shoot from eye node for consistancy
	melee = true;
	doRetraction = false;
	//raise your arm up or not
	armReady = false;
	minShotTime = 10;

	//casing = " ";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]					= "Activate";
	stateTimeoutValue[0]				= 0.5;
	stateTransitionOnTimeout[0]			= "Ready";
	stateScript[0]					= "onDraw";

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]			= "PreFire";
	stateAllowImageChange[1]			= true;

	stateName[2]					= "PreFire";
	stateScript[2]					= "HORARev";
	stateTimeoutValue[2]				= 0.01;
	stateTransitionOnTimeout[2] 			= "Fire";
	stateAllowImageChange[2]			= false;

	stateName[3]					= "Fire";
	stateTransitionOnTimeout[3]			= "CheckFire";
	stateTimeoutValue[3]				= 0.025;
	stateAllowImageChange[3]			= false;
	stateScript[3]					= "onFire";
	stateWaitForTimeout[3]				= true;

	stateName[4]					= "CheckFire";
	stateAllowImageChange[4]			= false;
	stateTransitionOnTriggerUp[4]			= "StopFire";
	stateTransitionOnTriggerDown[4]			= "Fire";

	stateName[5]					= "StopFire";
	stateTransitionOnTimeout[5]			= "Ready";
	stateTimeoutValue[5]				= 0.2;
	stateAllowImageChange[5]			= false;
	stateWaitForTimeout[5]				= true;
	stateScript[5]					= "HORAStop";
};

package HORAHORAHORA
{

	function PORUNAREFFImage::onMount(%this, %obj, %slot)
	{
		Parent::onMount(%this, %obj, %slot);
		%obj.mountImage(SilverChariotImage, 1);
	}
	function PORUNAREFFImage::onUnMount(%this, %obj, %slot)
	{
		Parent::onUnMount(%this, %obj, %slot);
		%obj.unMountImage(1);
		%obj.stopAudio(%slot);
	}
	function vectorRelativeShift(%forwards,%up,%shift)
	{
		%xShift = getWord(%shift,0);
		%yShift = getWord(%shift,1);
		%zShift = getWord(%shift,2);
		%xMod = vectorScale(%forwards,%xShift);
		%yMod = vectorScale(vectorCross(%forwards,%up),%yShift);
		%zMod = vectorScale(%up,%zShift);
		return vectorAdd(%xMod,vectorAdd(%yMod,%zMod));
	}

	function PORUNAREFFImage::OnDraw(%this,%obj,%slot)
	{
		if(!%obj.hasHorad) 
		{
			%obj.playAudio(%slot,OREMOSTANDATOSound);
			%obj.hasHorad = true;
		}
	}
	function PORUNAREFFImage::HORARev(%this,%obj,%slot)
	{
		%obj.playAudio(%slot,SilverChariotFireSound);
		%obj.mountImage(SilverChariotSlashingImage,1);
	}
	function PORUNAREFFImage::HORAStop(%this,%obj,%slot)
	{
		%obj.stopAudio(%slot);
 	  	%obj.mountImage(SilverChariotImage, 1);
	}
	function PORUNAREFFImage::onFire(%this,%obj,%slot)
	{
			%projectile = %this.projectile;
			%spread = 0.03;
			%muzPointCore = %obj.getMuzzlePoint(%slot);
			%forwardVect = %obj.getForwardVector();
			%upVect = %obj.getUpVector();
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);
			%subPos = VectorScale(%objectVelocity,0.005);
			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = VectorAdd(%subPos,VectorAdd(%obj.getEyePoint(),vectorRelativeShift(%forwardVect,%upVect,"1.5 0.6 0")));
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
	}
};
ActivatePackage(HORAHORAHORA);